'use strict';

exports.__esModule = true;

var _helpers = require('./helpers');

var _helpers2 = _interopRequireDefault(_helpers);

var _debug = require('./debug');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : { schema, mode, indent };
  return function () {
    var schema = options.schema,
        _options$mode = options.mode,
        mode = _options$mode === undefined ? 'print' : _options$mode,
        _options$indent = options.indent,
        indent = _options$indent === undefined ? 2 : _options$indent;


    return function (data, errors) {
      var customErrorToText = function customErrorToText(error) {
        return error.print(schema, data).join('\n');
      };
      var customErrorToStructure = function customErrorToStructure(error) {
        return error.getError(schema, data);
      };
      var customErrors = (0, _helpers2.default)(errors, indent);

      if (mode === 'print') {
        (0, _debug.log)(customErrors.map(customErrorToText).join());
      } else {
        return customErrors.map(customErrorToStructure);
      }
    };
  }();
};

module.exports = exports['default'];