'use strict';

exports.__esModule = true;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _findErrorPosition2 = require('./find-error-position');

var _findErrorPosition3 = _interopRequireDefault(_findErrorPosition2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (obj, dataPath) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return function (annotate) {
    var _options$delta = options.delta,
        delta = _options$delta === undefined ? 5 : _options$delta,
        _options$defaultColor = options.defaultColor,
        defaultColor = _options$defaultColor === undefined ? 'gray' : _options$defaultColor,
        _options$errorColor = options.errorColor,
        errorColor = _options$errorColor === undefined ? 'red' : _options$errorColor,
        _options$annotationCo = options.annotationColor,
        annotationColor = _options$annotationCo === undefined ? 'cyan' : _options$annotationCo,
        _options$gutterChar = options.gutterChar,
        gutterChar = _options$gutterChar === undefined ? '│' : _options$gutterChar,
        _options$annotationGu = options.annotationGutterChar,
        annotationGutterChar = _options$annotationGu === undefined ? '〉' : _options$annotationGu,
        _options$indent = options.indent,
        indent = _options$indent === undefined ? 2 : _options$indent;


    try {
      var jsonString = (0, _stringify2.default)(obj, null, indent);

      var _findErrorPosition = (0, _findErrorPosition3.default)(jsonString, dataPath),
          line = _findErrorPosition.line,
          column = _findErrorPosition.column;

      var lines = jsonString.split('\n');
      var gutterWidth = lines.length.toString().length;
      var annotationGutter = `${''.padStart(gutterWidth)}${annotationGutterChar}`;

      var min = Math.max(line - delta, 0);
      var max = Math.min(line + delta, lines.length - 1);
      var output = [];

      for (var i = min; i <= max; ++i) {
        var color = i === line ? errorColor : defaultColor;
        output.push(_chalk2.default`{${color} ${String(i + 1).padStart(gutterWidth)}${gutterChar} ${lines[i]}}`);
        if (i === line) {
          output = output.concat([
          // New line
          _chalk2.default`{${annotationColor} ${annotationGutter}}`, _chalk2.default`{${annotationColor} ${annotationGutter}${''.padStart(column)}${annotate()}}`,

          // New line
          _chalk2.default`{${annotationColor} ${annotationGutter}}`]);
        }
      }
      return output;
    } catch (e) {
      return [_chalk2.default`{red 😢  ${e.message || 'Error'}}`];
    }
  };
};

module.exports = exports['default'];