'use strict';

exports.__esModule = true;
exports.notUndefined = exports.concatAll = exports.getErrors = exports.getSiblings = exports.getChildren = exports.isEnumError = exports.isAnyOfError = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var eq = function eq(x) {
  return function (y) {
    return x === y;
  };
};
var not = function not(fn) {
  return function (x) {
    return !fn(x);
  };
};

var isXError = function isXError(x) {
  return function (error) {
    return error.keyword === x;
  };
};

var isAnyOfError = exports.isAnyOfError = isXError('anyOf');
var isEnumError = exports.isEnumError = isXError('enum');

var getChildren = exports.getChildren = function getChildren(node) {
  return node && (0, _values2.default)(node.children) || [];
};
var getSiblings = exports.getSiblings = function getSiblings(parent) {
  return function (node) {
    return getChildren(parent).filter(not(eq(node)));
  };
};
var getErrors = exports.getErrors = function getErrors(node) {
  return node && node.errors || [];
};

var concatAll = exports.concatAll = function concatAll(xs) {
  return function (ys) {
    return ys.reduce(function (zs, z) {
      return zs.concat(z);
    }, xs);
  };
};
var notUndefined = exports.notUndefined = function notUndefined(x) {
  return x !== undefined;
};