'use strict';

exports.__esModule = true;

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _print = require('../json/print');

var _print2 = _interopRequireDefault(_print);

var _findErrorPosition2 = require('../json/find-error-position');

var _findErrorPosition3 = _interopRequireDefault(_findErrorPosition2);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AdditionalPropValidationError = function (_BaseValidationError) {
  (0, _inherits3.default)(AdditionalPropValidationError, _BaseValidationError);

  function AdditionalPropValidationError() {
    (0, _classCallCheck3.default)(this, AdditionalPropValidationError);
    return (0, _possibleConstructorReturn3.default)(this, _BaseValidationError.apply(this, arguments));
  }

  AdditionalPropValidationError.prototype.print = function print(schema, data) {
    var output = [];
    var _options = this.options,
        message = _options.message,
        dataPath = _options.dataPath,
        params = _options.params;

    output.push(_chalk2.default`{red {bold ADDTIONAL PROPERTY} ${message}}\n`);

    return output.concat((0, _print2.default)(data, `${dataPath}/${params.additionalProperty}`, {
      indent: this.indent
    })(function () {
      return _chalk2.default`😲  {bold ${params.additionalProperty}} is not expected to be here!`;
    }));
    return [];

    // const expected = JSON.parse(JSON.stringify(data));
    // pointer.set(
    //   expected,
    //   `${dataPath}/${params.additionalProperty}`,
    //   undefined
    // );
    //
    // return output.concat(
    //   jestDiff(data, expected, {
    //     expand: false,
    //     aAnnotation: 'Extra',
    //     bAnnotation: 'Missing',
    //   })
    // );
  };

  AdditionalPropValidationError.prototype.getError = function getError(schema, data) {
    var _options2 = this.options,
        keyword = _options2.keyword,
        message = _options2.message,
        dataPath = _options2.dataPath,
        params = _options2.params;

    var jsonString = (0, _stringify2.default)(data, null, this.indent);

    var _findErrorPosition = (0, _findErrorPosition3.default)(jsonString, dataPath),
        line = _findErrorPosition.line,
        column = _findErrorPosition.column;

    return {
      line,
      column,
      error: `Property ${params.additionalProperty} is not expected to be here`
    };
  };

  return AdditionalPropValidationError;
}(_base2.default);

exports.default = AdditionalPropValidationError;
module.exports = exports['default'];