"use strict";

exports.__esModule = true;

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BaseValidationError = function () {
  function BaseValidationError() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var indent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 2;
    (0, _classCallCheck3.default)(this, BaseValidationError);

    this.options = options;
    this.indent = indent;
  }

  BaseValidationError.prototype.print = function print(schema, data) {
    throw new Error(`Implement the 'print' method inside ${this.constructor.name}!`);
  };

  BaseValidationError.prototype.getError = function getError(schema, data) {
    throw new Error(`Implement the 'getError' method inside ${this.constructor.name}!`);
  };

  return BaseValidationError;
}();

exports.default = BaseValidationError;
module.exports = exports["default"];