'use strict';

exports.__esModule = true;

var _helpers = require('./helpers');

var _helpers2 = _interopRequireDefault(_helpers);

var _debug = require('./debug');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (options = { schema, mode, indent }) => {
  const {
    schema,
    mode = 'print',
    indent = 2
  } = options;

  return (data, errors) => {
    const customErrorToText = error => error.print(schema, data).join('\n');
    const customErrorToStructure = error => error.getError(schema, data);
    const customErrors = (0, _helpers2.default)(errors, indent);

    if (mode === 'print') {
      (0, _debug.log)(customErrors.map(customErrorToText).join());
    } else {
      return customErrors.map(customErrorToStructure);
    }
  };
};

module.exports = exports['default'];