'use strict';

exports.__esModule = true;
const eq = x => y => x === y;
const not = fn => x => !fn(x);

const isXError = x => error => error.keyword === x;

const isAnyOfError = exports.isAnyOfError = isXError('anyOf');
const isEnumError = exports.isEnumError = isXError('enum');

const getChildren = exports.getChildren = node => node && Object.values(node.children) || [];
const getSiblings = exports.getSiblings = parent => node => getChildren(parent).filter(not(eq(node)));
const getErrors = exports.getErrors = node => node && node.errors || [];

const concatAll = exports.concatAll = xs => ys => ys.reduce((zs, z) => zs.concat(z), xs);
const notUndefined = exports.notUndefined = x => x !== undefined;