'use strict';

exports.__esModule = true;

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _print = require('../json/print');

var _print2 = _interopRequireDefault(_print);

var _findErrorPosition = require('../json/find-error-position');

var _findErrorPosition2 = _interopRequireDefault(_findErrorPosition);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class AdditionalPropValidationError extends _base2.default {
  print(schema, data) {
    const output = [];
    const { message, dataPath, params } = this.options;
    output.push(_chalk2.default`{red {bold ADDTIONAL PROPERTY} ${message}}\n`);

    return output.concat((0, _print2.default)(data, `${dataPath}/${params.additionalProperty}`, {
      indent: this.indent
    })(() => {
      return _chalk2.default`😲  {bold ${params.additionalProperty}} is not expected to be here!`;
    }));
    return [];

    // const expected = JSON.parse(JSON.stringify(data));
    // pointer.set(
    //   expected,
    //   `${dataPath}/${params.additionalProperty}`,
    //   undefined
    // );
    //
    // return output.concat(
    //   jestDiff(data, expected, {
    //     expand: false,
    //     aAnnotation: 'Extra',
    //     bAnnotation: 'Missing',
    //   })
    // );
  }

  getError(schema, data) {
    const { keyword, message, dataPath, params } = this.options;
    const jsonString = JSON.stringify(data, null, this.indent);
    const { line, column } = (0, _findErrorPosition2.default)(jsonString, dataPath);

    return {
      line,
      column,
      error: `Property ${params.additionalProperty} is not expected to be here`
    };
  }
}
exports.default = AdditionalPropValidationError;
module.exports = exports['default'];