'use strict';

exports.__esModule = true;

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _print = require('../json/print');

var _print2 = _interopRequireDefault(_print);

var _base = require('./base');

var _base2 = _interopRequireDefault(_base);

var _findErrorPosition = require('../json/find-error-position');

var _findErrorPosition2 = _interopRequireDefault(_findErrorPosition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class DefaultValidationError extends _base2.default {
  print(schema, data) {
    const output = [];
    const { keyword, message, dataPath, params } = this.options;
    output.push(_chalk2.default`{red {bold ${keyword}} ${message}}\n`);

    return output.concat((0, _print2.default)(data, dataPath, { indent: this.indent })(() => {
      return _chalk2.default`☝🏽  ${keyword} ${message}`;
    }));
  }

  getError(schema, data) {
    const { keyword, message, dataPath, params } = this.options;
    const jsonString = JSON.stringify(data, null, this.indent);
    const { line, column } = (0, _findErrorPosition2.default)(jsonString, dataPath);

    return {
      line,
      column,
      error: `${dataPath}: ${keyword} ${message}`
    };
  }
}
exports.default = DefaultValidationError;
module.exports = exports['default'];